--- common-functions.orig	2011-02-17 15:11:34.000000000 +0300
+++ common-functions	2011-02-18 15:31:01.000000000 +0300
@@ -5,7 +5,8 @@
 # This holds various functions that are common to the
 # various bin scripts.
 #
-
+CONVERT="/usr/bin/convert"
+ZIP="/usr/bin/zip -q"
 #
 # tolower(string)
 # Convert string to lowercase.
@@ -504,6 +505,10 @@
 	    a_type="image/tiff"
 	    a_desc="FAX Document (TIFF)"
 	    ;;
+	JPEG|jpeg|JPG|jpg)
+	    a_type="image/jpeg"
+	    a_desc="FAX Document (JPEG)"
+	    ;;
     esac
 
     for i in `LocalSequence 1 $nfiles`
@@ -607,6 +612,7 @@
 		    name="`basename $1 .tif`"
 		    $TIFF2PDF  -o $TMPDIR/$name.pdf $1
 		    echo "$TMPDIR/$name.pdf"
+                    ;;
 	    esac
 	    ;;
 	TIFF|TIF|tif|tiff)
@@ -627,14 +633,52 @@
 		TIFF|tiff|TIF|tif)
 		    TraceLog "Nothing neccessary"
 		    echo "$1"
-		    ;;
+                    ;;
+             esac
+             ;; 
+	JPEG|jpeg|JPG|jpg)
+	    TraceLog "Converting $1 to JPEG"
+	    case $2 in 
+	        PostScript|Postscript|PS|ps)
+                    TraceLog "Converting from PS to JPEG"
+                    name="`basename $1 .ps`"
+		    jpeg=1
+                    $CONVERT $1 $TMPDIR/$name.jpeg
+                    ;;
+                PDF|pdf)
+                    TraceLog "Converting from PDF to JPEG"
+                    name="`basename $1 .pdf`"
+		    jpeg=1
+                    $CONVERT $1 $TMPDIR/$name.jpeg
+                    ;;
+                TIFF|tiff|TIF|tif)
+                    TraceLog "Converting from TIFF to JPEG"
+                    name="`basename $1 .tif`"
+		    jpeg=1
+                    $CONVERT $1 $TMPDIR/$name.jpeg
+                    ;;
 	    esac
-	    ;;
+            ;;
 	*)
 	    TraceLog "Ignoring $1 to \"$3\""
 	    ;;
     esac
 
+   #
+   # A dirty workaround if a multi-page fax has been received.
+   #
+
+   if [ "`ls -l $TMPDIR/$name*.jpeg | wc -l`" -gt 1 ]
+   then
+	TraceLog "Multi-page file has been detected."
+        cd $TMPDIR
+	$ZIP $name.zip $name*.jpeg
+	a_type="application/zip"
+   	echo "$TMPDIR/$name.zip"
+   elif [ "$jpeg" -eq "1" ] 
+   then 
+	echo "$TMPDIR/$name.jpeg"
+   fi
 }
 
 LocalSequence ()
